package org.jeecg.modules.system.app.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.system.app.entity.AppKongfuZone;
import org.jeecg.modules.system.app.service.IAppKongfuZoneService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

/**
 * @Description: 首页金刚区管理
 * @Author: jeecg-boot
 * @Date:   2023-08-14
 * @Version: V1.0
 */
@Tag(name="首页金刚区管理")
@RestController
@RequestMapping("/app/appKongfuZone")
@Slf4j
public class AppKongfuZoneController extends JeecgController<AppKongfuZone, IAppKongfuZoneService> {
	@Autowired
	private IAppKongfuZoneService appKongfuZoneService;
	
	/**
	 * 分页列表查询
	 *
	 * @param appKongfuZone
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "首页金刚区管理-分页列表查询")
	@Operation(summary="首页金刚区管理-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<AppKongfuZone>> queryPageList(AppKongfuZone appKongfuZone,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<AppKongfuZone> queryWrapper = QueryGenerator.initQueryWrapper(appKongfuZone, req.getParameterMap());
		Page<AppKongfuZone> page = new Page<AppKongfuZone>(pageNo, pageSize);
		IPage<AppKongfuZone> pageList = appKongfuZoneService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param appKongfuZone
	 * @return
	 */
	@AutoLog(value = "首页金刚区管理-添加")
	@Operation(summary="首页金刚区管理-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody AppKongfuZone appKongfuZone) {
		appKongfuZoneService.save(appKongfuZone);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param appKongfuZone
	 * @return
	 */
	@AutoLog(value = "首页金刚区管理-编辑")
	@Operation(summary="首页金刚区管理-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody AppKongfuZone appKongfuZone) {
		appKongfuZoneService.updateById(appKongfuZone);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "首页金刚区管理-通过id删除")
	@Operation(summary="首页金刚区管理-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		appKongfuZoneService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "首页金刚区管理-批量删除")
	@Operation(summary="首页金刚区管理-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.appKongfuZoneService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "首页金刚区管理-通过id查询")
	@Operation(summary="首页金刚区管理-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<AppKongfuZone> queryById(@RequestParam(name="id",required=true) String id) {
		AppKongfuZone appKongfuZone = appKongfuZoneService.getById(id);
		if(appKongfuZone==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(appKongfuZone);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param appKongfuZone
    */
    @RequiresPermissions("app:app_kongfu_zone:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, AppKongfuZone appKongfuZone) {
        return super.exportXls(request, appKongfuZone, AppKongfuZone.class, "首页金刚区管理");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("app:app_kongfu_zone:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, AppKongfuZone.class);
    }

}
